#pragma once
#include <Windows.h>
#include <stdio.h>
#include "GLRenderer.h"

class MainWnd
{
public:
  MainWnd(HINSTANCE hInstance, LPSTR lpCmdLine);
  ~MainWnd();

protected:
  void Init(HWND hwnd);
  void OnSize(UINT nType, int cx, int cy);
  void OnDraw();
  void OnLButtonDown(UINT nFlags, int x, int y);
  void OnMouseMove(UINT nFlags, int x, int y);
  void OnLButtonUp(UINT nFlags, int x, int y);
  void OnMouseWheel(WPARAM wParam, int x, int y);
  void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
  void OnGLRedraw(LPARAM lParam);
  void OnTimer(UINT nIDEvent);
  void OnHScroll(WPARAM wParam, LPARAM lParam);

  friend LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

private:
  HINSTANCE hinstance;
  HWND hwnd;
  GLRenderer renderer;
  HWND info, scroll;

  char filename[MAX_PATH];
  FILE* file;
  int noofframes;
  unsigned __int64* offsets;

  bool toworld;
  int maxwldpts, maxmatchpts;
  POINTDATA* worldpoints, *matchpoints;

  void LoadFrame(int frame);
  void AppendInfoText(const wchar_t* text);
  void CaptureVideo();
  int FormatNumber(wchar_t* buffer, const int bufflen, double value, int dps);
};
